%global _python_bytecompile_extra %nil

%global compat_build 0

%global maj_ver 11
%global min_ver 0
%global patch_ver 1
#global rc_ver 2
%global baserelease 4

%global clang_tools_binaries \
	%{_bindir}/clang-apply-replacements \
	%{_bindir}/clang-change-namespace \
	%{_bindir}/clang-check \
	%{_bindir}/clang-doc \
	%{_bindir}/clang-extdef-mapping \
	%{_bindir}/clang-format \
	%{_bindir}/clang-include-fixer \
	%{_bindir}/clang-move \
	%{_bindir}/clang-offload-bundler \
	%{_bindir}/clang-offload-wrapper \
	%{_bindir}/clang-query \
	%{_bindir}/clang-refactor \
	%{_bindir}/clang-rename \
	%{_bindir}/clang-reorder-fields \
	%{_bindir}/clang-scan-deps \
	%{_bindir}/clang-tidy \
	%{_bindir}/clangd \
	%{_bindir}/diagtool \
	%{_bindir}/hmaptool \
	%{_bindir}/pp-trace

%global clang_binaries \
	%{_bindir}/clang \
	%{_bindir}/clang++ \
	%{_bindir}/clang-%{maj_ver} \
	%{_bindir}/clang++-%{maj_ver} \
	%{_bindir}/clang-cl \
	%{_bindir}/clang-cpp \


%define _disable_ld_no_undefined 0

# (tv) fix requires:
%global __requires_exclude devel\\(libclang
# (tv) fix deps:
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^/usr/bin/tcsh

%define major %maj_ver.%min_ver
%define minor 1

%define libname %mklibname clang %major
%define devname %mklibname -d clang

%if 0%{?compat_build}
%global pkg_name clang%{maj_ver}.%{min_ver}
# Install clang to same prefix as llvm, so that apps that use llvm-config
# will also be able to find clang libs.
%global install_prefix %{_libdir}/llvm%{maj_ver}.%{min_ver}
%global install_bindir %{install_prefix}/bin
%global install_includedir %{install_prefix}/include
%global install_libdir %{install_prefix}/lib
%global pkg_bindir %{install_bindir}
%global pkg_includedir %{_includedir}/llvm%{maj_ver}.%{min_ver}
%global pkg_libdir %{install_libdir}
%else
%global pkg_name clang
%global install_prefix /usr
%global pkg_libdir %{_libdir}
%endif

%bcond_without python3

%global build_install_prefix %{buildroot}%{install_prefix}

%global clang_srcdir clang-%{version}%{?rc_ver:rc%{rc_ver}}.src
%global clang_tools_srcdir clang-tools-extra-%{version}%{?rc_ver:rc%{rc_ver}}.src

Name:		%pkg_name
Version:	%{maj_ver}.%{min_ver}.%{patch_ver}
Release:	%mkrel %{baserelease}%{?rc_ver:.rc%{rc_ver}}
Summary:	A C language family front-end for LLVM
Group:		Development/Other

License:	NCSA
URL:		http://llvm.org
Source0:	https://github.com/llvm/llvm-project/releases/download/llvmorg-%{version}%{?rc_ver:-rc%{rc_ver}}/%{clang_srcdir}.tar.xz
Source3:	https://github.com/llvm/llvm-project/releases/download/llvmorg-%{version}%{?rc_ver:-rc%{rc_ver}}/%{clang_srcdir}.tar.xz.sig
%if !0%{?compat_build}
Source1:	https://github.com/llvm/llvm-project/releases/download/llvmorg-%{version}%{?rc_ver:-rc%{rc_ver}}/%{clang_tools_srcdir}.tar.xz
Source2:	https://github.com/llvm/llvm-project/releases/download/llvmorg-%{version}%{?rc_ver:-rc%{rc_ver}}/%{clang_tools_srcdir}.tar.xz.sig
%endif
Source4:	tstellar-gpg-key.asc

Patch4:		0002-gtest-reorg.patch
Patch11:	0001-ToolChain-Add-lgcc_s-to-the-linker-flags-when-using-.patch
Patch13:	0001-Make-funwind-tables-the-default-for-all-archs.patch

# Not Upstream
Patch15:	0001-clang-Don-t-install-static-libraries.patch
Patch16:	0001-clang-Fix-spurious-test-failure.patch
Patch17:	0001-Driver-Prefer-gcc-toolchains-with-libgcc_s.so-when-n.patch

Patch100:	cfe-8.0.0-detect-Mageia.patch

BuildRequires:	gcc
BuildRequires:	gcc-c++
BuildRequires:	cmake
BuildRequires:	ninja-build
%if 0%{?compat_build}
BuildRequires:	llvm%{maj_ver}.%{min_ver}-devel = %{version}
BuildRequires:	llvm%{maj_ver}.%{min_ver}-static = %{version}
%else
BuildRequires:	llvm-devel = %{version}
BuildRequires:	llvm-test = %{version}
# llvm-static is required, because clang-tablegen needs libLLVMTableGen, which
# is not included in libLLVM.so.
BuildRequires:  llvm-static = %{version}
BuildRequires:	llvm-googletest = %{version}
%endif

BuildRequires:	pkgconfig(libxml-2.0)
BuildRequires:  ncurses-devel
# According to https://fedoraproject.org/wiki/Packaging:Emacs a package
# should BuildRequires: emacs if it packages emacs integration files.
BuildRequires:	emacs

# These build dependencies are required for the test suite.
%if %with python3
# The testsuite uses /usr/bin/lit which is part of the python3-lit package.
BuildRequires:  python3-lit
%endif

BuildRequires: python3-sphinx
BuildRequires: libatomic-devel

# We need python3-devel for pathfix.py.
BuildRequires:	python3-devel


# For origin certification
BuildRequires:	gnupg2

# scan-build uses these perl modules so they need to be installed in order
# to run the tests.
BuildRequires: perl(Digest::MD5)
BuildRequires: perl(File::Copy)
BuildRequires: perl(File::Find)
BuildRequires: perl(File::Path)
BuildRequires: perl(File::Temp)
BuildRequires: perl(FindBin)
BuildRequires: perl(Hash::Util)
BuildRequires: perl(lib)
BuildRequires: perl(Term::ANSIColor)
BuildRequires: perl(Text::ParseWords)
BuildRequires: perl(Sys::Hostname)

Requires:	%{libname} = %{version}-%{release}

# clang requires gcc, clang++ requires libstdc++-devel
# - https://bugzilla.redhat.com/show_bug.cgi?id=1021645
# - https://bugzilla.redhat.com/show_bug.cgi?id=1158594
Requires:	libstdc++-static-devel
Requires:	gcc-c++

Provides: clang(major) = %{maj_ver}

Conflicts:	compiler-rt < %{version}
Conflicts:	compiler-rt > %{version}

%description
clang: noun
    1. A loud, resonant, metallic sound.
    2. The strident call of a crane or goose.
    3. C-language family front-end toolkit.

The goal of the Clang project is to create a new C, C++, Objective C
and Objective C++ front-end for the LLVM compiler. Its tools are built
as libraries and designed to be loosely-coupled and extensible.

Install compiler-rt if you want the Blocks C language extension or to
enable sanitization and profiling options when building, and
libomp-devel to enable -fopenmp.

%package -n %libname
Summary: Runtime library for clang
Requires: %{name}-resource-filesystem%{?_isa} = %{version}
Recommends: compiler-rt%{?_isa} = %{version}
# libomp-devel is required, so clang can find the omp.h header when compiling
# with -fopenmp.
Recommends: libomp-devel%{_isa} = %{version}
Recommends: libomp%{_isa} = %{version}

%description -n %libname
Runtime library for clang.

%package -n %devname
Summary: Development header files for clang
Provides: clang-devel = %version-%release
%if !0%{?compat_build}
Requires: %{name}%{?_isa} = %{version}-%{release}
# The clang CMake files reference tools from clang-tools-extra.
Requires: %{name}-tools-extra%{?_isa} = %{version}-%{release}
Requires: %{libname} = %{version}-%{release}
%endif

%description -n %devname
Development header files for clang.

%package resource-filesystem
Summary: Filesystem package that owns the clang resource directory
Provides: %{name}-resource-filesystem(major) = %{maj_ver}

%description resource-filesystem
This package owns the clang resouce directory: $libdir/clang/$version/

%if !0%{?compat_build}
%package analyzer
Summary:	A source code analysis framework
License:	NCSA and MIT
BuildArch:	noarch
Requires:	%{name} = %{version}-%{release}

%description analyzer
The Clang Static Analyzer consists of both a source code analysis
framework and a standalone tool that finds bugs in C and Objective-C
programs. The standalone tool is invoked from the command-line, and is
intended to run in tandem with a build of a project or code base.

%package tools-extra
Summary: Extra tools for clang
Group:	 Development/Other
Requires: %{mklibname clang %major}%{?_isa} = %{version}
Requires: %libname%{?_isa} = %{version}

%description tools-extra
A set of extra tools built using Clang's tooling API.

# Put git-clang-format in its own package, because it Requires git
# and we don't want to force users to install all those dependenices if they
# just want clang.
%package -n git-clang-format
Summary:	Integration of clang-format for git
Group:	 Development/Other
Requires:	%{name}-tools-extra = %{version}-%{release}
Requires: git
Requires: python3

%description -n git-clang-format
clang-format integration for git.


%package -n python3-clang
Summary: Python3 bindings for clang
Requires: %{libname}%{?_isa} = %{version}-%{release}
Requires: python3
%description -n python3-clang
%{summary}.


%endif


%prep
%{gpgverify} --keyring='%{SOURCE4}' --signature='%{SOURCE3}' --data='%{SOURCE0}'

%if 0%{?compat_build}
%autosetup -n %{clang_srcdir} -p1
%else

%{gpgverify} --keyring='%{SOURCE4}' --signature='%{SOURCE2}' --data='%{SOURCE1}'
%setup -T -q -b 1 -n %{clang_tools_srcdir}


pathfix.py -i %{__python3} -pn \
	clang-tidy/tool/*.py \
	clang-include-fixer/find-all-symbols/tool/run-find-all-symbols.py

%setup -q -n %{clang_srcdir}

%patch4 -p1 -b .gtest
%patch11 -p1 -b .libcxx-fix
%patch13 -p2 -b .unwind-all
%patch15 -p2 -b .no-install-static
%patch16 -p2 -b .test-fix2
%patch17 -p1 -b .check-gcc_s

%patch100 -p1 -b .mga

mv ../%{clang_tools_srcdir} tools/extra

pathfix.py -i %{__python3} -pn \
	tools/clang-format/*.py \
	tools/clang-format/git-clang-format \
	utils/hmaptool/hmaptool \
	tools/scan-view/bin/scan-view
%endif

%build

# We run the builders out of memory on armv7 and i686 when LTO is enabled
%ifarch %{arm} i686
%define _lto_cflags %{nil}
%else
# This package does not ship any object files or static libraries, so we
# don't need -ffat-lto-objects.
%global _lto_cflags %(echo %{_lto_cflags} | sed 's/-ffat-lto-objects//')
%endif

%if 0%{?__isa_bits} == 64
sed -i 's/\@FEDORA_LLVM_LIB_SUFFIX\@/64/g' test/lit.cfg.py
%else
sed -i 's/\@FEDORA_LLVM_LIB_SUFFIX\@//g' test/lit.cfg.py
%endif

# FC compatibility:
%global _vpath_builddir _build

%ifarch s390 s390x %{arm} %ix86 ppc64le
# Decrease debuginfo verbosity to reduce memory consumption during final library linking
%global optflags %(echo %{optflags} | sed 's/-g /-g1 /')
%endif

# -DCMAKE_INSTALL_RPATH=";" is a workaround for llvm manually setting the
# rpath of libraries and binaries.  llvm will skip the manual setting
# if CAMKE_INSTALL_RPATH is set to a value, but cmake interprets this value
# as nothing, so it sets the rpath to "" when installing.
%cmake  -G Ninja \
	-DLLVM_PARALLEL_LINK_JOBS=1 \
	-DLLVM_LINK_LLVM_DYLIB:BOOL=ON \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DPYTHON_EXECUTABLE=%{__python3} \
	-DCMAKE_INSTALL_RPATH:BOOL=";" \
%ifarch s390 s390x %{arm} %ix86 ppc64le
	-DCMAKE_C_FLAGS_RELWITHDEBINFO="%{optflags} -DNDEBUG" \
	-DCMAKE_CXX_FLAGS_RELWITHDEBINFO="%{optflags} -DNDEBUG" \
%endif
%if 0%{?compat_build}
	-DLLVM_CONFIG:FILEPATH=%{_bindir}/llvm-config-%{maj_ver}.%{min_ver}-%{__isa_bits} \
	-DCMAKE_INSTALL_PREFIX=%{install_prefix} \
	-DCLANG_INCLUDE_TESTS:BOOL=OFF \
%else
	-DCLANG_INCLUDE_TESTS:BOOL=ON \
	-DLLVM_EXTERNAL_LIT=%{_bindir}/lit \
	-DLLVM_MAIN_SRC_DIR=%{_datadir}/llvm/src \
%if 0%{?__isa_bits} == 64
	-DLLVM_LIBDIR_SUFFIX=64 \
%else
	-DLLVM_LIBDIR_SUFFIX= \
%endif
%endif
	\
%if !0%{compat_build}
	-DLLVM_TABLEGEN_EXE:FILEPATH=%{_bindir}/llvm-tblgen \
%else
	-DLLVM_TABLEGEN_EXE:FILEPATH=%{_bindir}/llvm-tblgen-%{maj_ver}.%{min_ver} \
%endif
	-DCLANG_ENABLE_ARCMT:BOOL=ON \
	-DCLANG_ENABLE_STATIC_ANALYZER:BOOL=ON \
	-DCLANG_INCLUDE_DOCS:BOOL=ON \
	-DCLANG_PLUGIN_SUPPORT:BOOL=ON \
	-DENABLE_LINKER_BUILD_ID:BOOL=ON \
	-DLLVM_ENABLE_EH=ON \
	-DLLVM_ENABLE_RTTI=ON \
	-DLLVM_BUILD_DOCS=ON \
	-DLLVM_ENABLE_SPHINX=ON \
	-DCLANG_LINK_CLANG_DYLIB=ON \
	-DSPHINX_WARNINGS_AS_ERRORS=OFF \
	\
	-DCLANG_BUILD_EXAMPLES:BOOL=OFF \
	-DBUILD_SHARED_LIBS=OFF \
	-DCLANG_REPOSITORY_STRING="%{?mageia:Mageia}%{?rhel:Red Hat} %{version}-%{release}"

%cmake_build

%install

%cmake_install

%if 0%{?compat_build}

# Remove binaries/other files
rm -Rf %{buildroot}%{install_bindir}
rm -Rf %{buildroot}%{install_prefix}/share
rm -Rf %{buildroot}%{install_prefix}/libexec

# Move include files
mkdir -p %{buildroot}%{pkg_includedir}
mv  %{buildroot}/%{install_includedir}/clang %{buildroot}/%{pkg_includedir}/
mv  %{buildroot}/%{install_includedir}/clang-c %{buildroot}/%{pkg_includedir}/

%else

# install clang python bindings
mkdir -p %{buildroot}%{python3_sitelib}/clang/
install -p -m644 bindings/python/clang/* %{buildroot}%{python3_sitelib}/clang/
%py_byte_compile %{__python3} %{buildroot}%{python3_sitelib}/clang


# Move emacs integration files to the correct directory
mkdir -p %{buildroot}%{_emacs_sitestartdir}
for f in clang-format.el clang-rename.el clang-include-fixer.el; do
mv %{buildroot}{%{_datadir}/clang,%{_emacs_sitestartdir}}/$f
done

# remove editor integrations (bbedit, sublime, emacs, vim)
rm -vf %{buildroot}%{_datadir}/clang/clang-format-bbedit.applescript
rm -vf %{buildroot}%{_datadir}/clang/clang-format-sublime.py*

# TODO: Package html docs
rm -Rvf %{buildroot}%{_docdir}/clang/html
rm -Rvf %{buildroot}%{_datadir}/clang/clang-doc-default-stylesheet.css
rm -Rvf %{buildroot}%{_datadir}/clang/index.js

# TODO: What are the Fedora guidelines for packaging bash autocomplete files?
rm -vf %{buildroot}%{_datadir}/clang/bash-autocomplete.sh

# Create Manpage symlinks
ln -s clang.1.xz %{buildroot}%{_mandir}/man1/clang++.1.xz
ln -s clang.1.xz %{buildroot}%{_mandir}/man1/clang-%{maj_ver}.1.xz
ln -s clang.1.xz %{buildroot}%{_mandir}/man1/clang++-%{maj_ver}.1.xz

# Add clang++-{version} symlink
ln -s clang++ %{buildroot}%{_bindir}/clang++-%{maj_ver}


# Fix permission
chmod u-x %{buildroot}%{_mandir}/man1/scan-build.1*

# create a link to clang's resource directory that is "constant" across minor
# version bumps
# this is required for packages like ccls that hardcode the link to clang's
# resource directory to not require rebuilds on minor version bumps
# Fix for bugs like rhbz#1807574
pushd %{buildroot}%{_libdir}/clang/
ln -s %{version} %{maj_ver}
popd

# Create sub-directories in the clang resource directory that will be
# populated by other packages
mkdir -p %{buildroot}%{_libdir}/clang/%{version}/{include,lib,share}/

%endif

# Remove clang-tidy headers.  We don't ship the libraries for these.
rm -Rvf %{buildroot}%{_includedir}/clang-tidy/

%check
%if !0%{?compat_build}
# requires lit.py from LLVM utilities
# FIXME: Fix failing ARM tests
LD_LIBRARY_PATH=%{buildroot}/%{_libdir} %cmake_build --target check-all || \
%ifarch %{arm}
:
%else
:
%endif

%endif


%if !0%{?compat_build}
%files
%license LICENSE.TXT
%{clang_binaries}
%{_mandir}/man1/clang.1*
%{_mandir}/man1/clang++.1*
%{_mandir}/man1/clang-%{maj_ver}.1.*
%{_mandir}/man1/clang++-%{maj_ver}.1.*
%endif

%files -n %libname
%if !0%{?compat_build}
%{_libdir}/clang/
%{_libdir}/*.so.*
%else
%{pkg_libdir}/*.so.*
%{pkg_libdir}/clang/%{version}
%endif

%files -n %devname
%if !0%{?compat_build}
%{_libdir}/*.so
%{_includedir}/clang/
%{_includedir}/clang-c/
%{_libdir}/cmake/*
%dir %{_datadir}/clang/
%else
%{pkg_libdir}/*.so
%{pkg_includedir}/clang/
%{pkg_includedir}/clang-c/
%{pkg_libdir}/cmake/
%endif

%files resource-filesystem
%dir %{pkg_libdir}/clang/%{version}/
%dir %{pkg_libdir}/clang/%{version}/include/
%dir %{pkg_libdir}/clang/%{version}/lib/
%dir %{pkg_libdir}/clang/%{version}/share/
%if !0%{?compat_build}
%{pkg_libdir}/clang/%{maj_ver}
%endif

%if !0%{?compat_build}
%files analyzer
%{_bindir}/scan-view
%{_bindir}/scan-build
%{_libexecdir}/ccc-analyzer
%{_libexecdir}/c++-analyzer
%{_datadir}/scan-view/
%{_datadir}/scan-build/
%{_mandir}/man1/scan-build.1.*

%files tools-extra
%{clang_tools_binaries}
%{_bindir}/c-index-test
%{_bindir}/find-all-symbols
%{_bindir}/modularize
%{_mandir}/man1/diagtool.1*
%{_emacs_sitestartdir}/clang-format.el
%{_emacs_sitestartdir}/clang-rename.el
%{_emacs_sitestartdir}/clang-include-fixer.el
%{_datadir}/clang/clang-format.py*
%{_datadir}/clang/clang-format-diff.py*
%{_datadir}/clang/clang-include-fixer.py*
%{_datadir}/clang/clang-tidy-diff.py*
%{_datadir}/clang/run-clang-tidy.py*
%{_datadir}/clang/run-find-all-symbols.py*
%{_datadir}/clang/clang-rename.py*

%files -n git-clang-format
%{_bindir}/git-clang-format

%files -n python3-clang
%{python3_sitelib}/clang/

%endif


%changelog
* Thu Jan 07 2021 tv <tv> 11.0.1-4.mga8
+ Revision: 1669465
- LLVM 11.0.1 final

* Tue Dec 22 2020 tv <tv> 11.0.1-3.rc2.mga8
+ Revision: 1662958
- llvm 11.0.1-rc2

* Thu Dec 03 2020 tv <tv> 11.0.1-1.rc1.mga8
+ Revision: 1652052
- ignore testsuite failure for now
- llvm 11.0.1-rc1
- stop ignoring testsuite results

* Thu Nov 26 2020 tv <tv> 11.0.0-3.mga8
+ Revision: 1649427
- ignore %%check failure for now
- 11.0.0

* Fri Oct 16 2020 ghibo <ghibo> 10.0.1-2.mga8
+ Revision: 1636368
- Rebuild to fix weird package release number

* Thu Oct 08 2020 akien <akien> 10.0.1-1.1.mga8
+ Revision: 1632746
- Version 10.0.1
+ tv <tv>
- bump rel b/c previous build failed due to 0 free disk space :-(
- Update cmake macro usage
- Finalize source verification
- Add cet.h header
- Accept multiple --config options

* Thu Jun 04 2020 tv <tv> 10.0.0-4.mga8
+ Revision: 1590273
- Add symlink to %%{_libdir}/clang/%%{maj_ver} for persistent access to the resource directory accross minor version bumps

* Wed May 20 2020 tv <tv> 10.0.0-2.mga8
+ Revision: 1586350
- Backport "Fix undefined behaviour... `std::out_of_range` exception" (rhbz#1825593)

* Tue Mar 24 2020 tv <tv> 10.0.0-1.mga8
+ Revision: 1559495
- 10.0.0 final

* Tue Mar 24 2020 tv <tv> 10.0.0-0.10.rc5.mga8
+ Revision: 1559209
- Update git-clang-format dependency (rhbz#1815913)

* Sun Mar 22 2020 tv <tv> 10.0.0-0.9.rc5.mga8
+ Revision: 1558776
- Add dependency on libomp-devel

* Sun Mar 22 2020 tv <tv> 10.0.0-0.8.6.rc5.mga8
+ Revision: 1558758
- rebuild b/c of armv7 failure

* Sat Mar 21 2020 tv <tv> 10.0.0-0.8.5.rc5.mga8
+ Revision: 1558718
- rebuild for missing pkg on arm

* Sat Mar 21 2020 tv <tv> 10.0.0-0.8.4.rc5.mga8
+ Revision: 1558692
- rebuild for missing pkg on arm
- rebuild for missing pkg on arm

* Sat Mar 21 2020 tv <tv> 10.0.0-0.8.2.rc5.mga8
+ Revision: 1558630
- revert workaround now that BS is fixed
- compile with -O1 instead of -O2 on aarch64 x86_64 b/c of BS timeouts)
- 10.0.0 rc5
- 10.0.0 rc4
- remove old obsoletes
- add support for compat_build
- remove cpu & debug libmitations on aarch64 now that've fast BS
- Move clang-format.el along with tools-extra (rhbz#1812487)
  With the current setup, if you only install clang-tools-extra, the
  package clang-format is not found by Emacs.
  A similar change was made for the Python scripts

* Thu Mar 05 2020 tv <tv> 10.0.0-0.5.rc3.mga8
+ Revision: 1554126
- 10.0.0 RC3
- 10.0.0 rc2
- Explicitly conflicts with any different compiler-rt version (rhbz#1800705)

* Wed Feb 12 2020 tv <tv> 10.0.0-0.2.rc1.mga8
+ Revision: 1502233
- 10.0.0 rc1
- Stop shipping individual component libraries
- https://fedoraproject.org/wiki/Changes/Stop-Shipping-Individual-Component-Libraries-In-clang-lib-Package
+ wally <wally>
- build with new cmake macros

* Sat Sep 21 2019 tv <tv> 9.0.0-1.mga8
+ Revision: 1444193
- 9.0.0 Release

* Tue Sep 17 2019 tv <tv> 9.0.0-0.2.rc3.mga8
+ Revision: 1442787
- disable %%_python_bytecompile_extra
- drop BR on python2-lit
- 9.0.0 Release candidate 3
+ wally <wally>
- drop python2-sphinx BR

* Sat Apr 13 2019 tv <tv> 8.0.0-1.mga7
+ Revision: 1389634
- ignore one test failure for now
- 8.0.0 final
- Cleanup specfile after llvm dependency update
- Fix compiling with -stdlib=libc++
- Update patch for Python3 port of scan-view
- Working CI test suite
- Workaround gcc-9 bug when compiling bitfields
- Fix uninitialized error detected by gcc-9

* Sat Dec 29 2018 tv <tv> 7.0.1-1.mga7
+ Revision: 1346606
- 7.0.1
- Fix for rhbz#1657544
- Install proper manpage symlinks for clang/clang++ versions
- No longer Ignore -fstack-clash-protection option
- Ensure rpmlint passes on specfile
- Drop python2 dependency from clang-tools-extra
- Prune unneeded reference to llvm-test-suite sub-package
- Run 'make check-all' instead of 'make check-clang'

* Sun Oct 21 2018 tv <tv> 7.0.0-8.mga7
+ Revision: 1323172
- fix test-suite deps as we don't split libstdc++-static like FC

* Sat Oct 13 2018 tv <tv> 7.0.0-7.mga7
+ Revision: 1319966
- fix test deps

* Wed Oct 03 2018 wally <wally> 7.0.0-5.mga7
+ Revision: 1317201
- build with 4 cores max on aarch64

* Wed Oct 03 2018 tv <tv> 7.0.0-4.mga7
+ Revision: 1316091
- Use correct shebang substitution for python scripts
- Drop python2 dependency
+ wally <wally>
- add Mageia to clang repository string
+ pterjan <pterjan>
- Also decrease memory usage on aarch64
- Add aarch64 triple, it currently fails to find gcc headers
- Drop duplicate lines

* Sun Sep 23 2018 tv <tv> 7.0.0-2.mga7
+ Revision: 1302242
- drop armv5tl workarounds
- temp BR on python2-sphinx while waiting for new python3
- Move llvm-test-suite into a sub-package
- new release

* Sat Sep 22 2018 umeabot <umeabot> 6.0.1-2.mga7
+ Revision: 1296281
- Mageia 7 Mass Rebuild

* Thu Jun 28 2018 tv <tv> 6.0.1-1.mga7
+ Revision: 1240607
- 6.0.1

* Fri Jun 15 2018 tv <tv> 6.0.1-0.2.rc2.mga7
+ Revision: 1237000
- new release

* Thu May 31 2018 tv <tv> 6.0.1-0.2.rc1.mga7
+ Revision: 1233324
- move devel files into dev pkg
- fix major

* Tue May 15 2018 tv <tv> 6.0.1-0.1.rc1.mga7
+ Revision: 1229705
- 6.0.1-rc1 Release
- Decrease debuginfo verbosity on arm in order to reduce memory consumption
  during final library linking

* Sat Mar 24 2018 tv <tv> 6.0.0-6.mga7
+ Revision: 1211831
- Add a clang++-{version} symlink (rhbz#1534098)
- Use correct script for running lit tests

* Thu Mar 22 2018 tv <tv> 6.0.0-5.mga7
+ Revision: 1211318
- rediff mageia patch

* Thu Mar 22 2018 tv <tv> 6.0.0-4.mga7
+ Revision: 1211297
- Fix toolchain detection so we don't default to using cross-compilers
  (rhbz#14824b1)

* Tue Mar 20 2018 tv <tv> 6.0.0-3.mga7
+ Revision: 1210781
- fix filelist
- new release

* Tue Dec 26 2017 tv <tv> 5.0.1-3.mga7
+ Revision: 1185119
- 5.0.1
- Make compiler-rt a weak dependency and add a weak dependency on libomp

* Wed Nov 22 2017 tv <tv> 5.0.0-3.mga7
+ Revision: 1178837
- fix python2-clang's deps

* Wed Oct 25 2017 tv <tv> 5.0.0-2.mga7
+ Revision: 1173564
- bump major

* Wed Oct 18 2017 tv <tv> 5.0.0-1.mga7
+ Revision: 1172647
- rediff mga patch
- new release

* Fri Sep 22 2017 tv <tv> 4.0.1-11.mga7
+ Revision: 1156948
- make clang-devel requires clang

* Thu Sep 21 2017 tv <tv> 4.0.1-10.mga7
+ Revision: 1156908
- reenable mga patch

* Thu Sep 21 2017 tv <tv> 4.0.1-7.mga7
+ Revision: 1156811
- ignore more testsuite faillures
- fix mga patch
- bootstrap w/o mga patch
- fix build by BR python-sphinx
- new release
- new tools-extra & git-clang-format subpkgs (rhbz#1328091)
- Generate man pages
- Run llvm test-suite
- Enable build-id by default (rhbz#1432403)
- Enable eh/rtti, which are required by lldb

* Tue Mar 28 2017 tmb <tmb> 3.9.1-4.mga6
+ Revision: 1095109
- rebuild for armv7hl

* Tue Mar 28 2017 tmb <tmb> 3.9.1-3.mga6
+ Revision: 1095072
- dont require compiler-rt on armv5tl

* Tue Mar 28 2017 tmb <tmb> 3.9.1-2.mga6
+ Revision: 1095014
- rebuild with new llvm

* Sat Jan 07 2017 ghibo <ghibo> 3.9.1-1.mga6
+ Revision: 1080455
- Update to release 3.9.1.
- Removed GCC patches (merged upstream).
- Rework Patch10 for Mageia detecting.

* Mon Oct 03 2016 tv <tv> 3.8.1-4.mga6
+ Revision: 1058299
- add GCC abi_tag support (rhbz#1282645)

* Thu Sep 08 2016 pterjan <pterjan> 3.8.1-3.mga6
+ Revision: 1050874
- Add armv5tl-mageia-linux-gnueabi, hopefuly at the correct place
- Add armv7hl-mageia-linux-gnueabi
+ shlomif <shlomif>
- Fix clang invocation on mageia ( MGA#18138 ).
- Copy a patch from the old llvm package that was left out after clang was
  split from it. We still need to handle the ARM architecture.

* Tue Jul 12 2016 tmb <tmb> 3.8.1-2.mga6
+ Revision: 1041254
- update to 3.8.1 (maintenance release)

* Tue Mar 29 2016 pterjan <pterjan> 3.8.0-9.mga6
+ Revision: 996290
- Rebuild to get it on arm

* Tue Mar 15 2016 tv <tv> 3.8.0-8.mga6
+ Revision: 990894
- rebuild b/c clang-analyzer was not uploaded by BS

* Mon Mar 14 2016 tv <tv> 3.8.0-7.mga6
+ Revision: 990522
- submit to core/release

* Sat Mar 12 2016 tv <tv> 3.8.0-6.mga6
+ Revision: 989660
- fix lib requires
- provides clang-devel

* Sat Mar 12 2016 tv <tv> 3.8.0-4.mga6
+ Revision: 989586
- fix requires

* Sat Mar 12 2016 tv <tv> 3.8.0-3.mga6
+ Revision: 989532
- fix upload (summary-ended-with-dot)
- adjust file list
- fix linking
- 3.8.0 final
- imported package clang
+ tmb <tmb>
- try to disable parallell build

